import { defaultCommands, editHistory } from "./extensions/commands.js";
import { copyButton } from "./extensions/copy-button/index.js";
import { cursorPosition } from "./extensions/cursor.js";
import { readOnlyCodeFolding, markdownFolding, blockCommentFolding } from "./extensions/folding/index.js";
import { indentGuides } from "./extensions/guides.js";
import { matchBrackets } from "./extensions/match-brackets/index.js";
import { highlightBracketPairs } from "./extensions/match-brackets/highlight.js";
import { matchTags, highlightMatchingTags } from "./extensions/match-tags.js";
import { s as searchWidget, h as highlightSelectionMatches } from "./selection-oblxf2tD.js";
import "./index-k8FOC6Zh.js";
import "./core-7ijP1_R8.js";
import "solid-js";
import "./index-SjNLqops.js";
import "solid-js/web";
import "./replace-JeD8jhG9.js";
import "./other-PlCGrMd2.js";
const basicSetup = [
  /* @__PURE__ */ matchBrackets(),
  /* @__PURE__ */ highlightBracketPairs(),
  /* @__PURE__ */ matchTags(),
  /* @__PURE__ */ highlightMatchingTags(),
  /* @__PURE__ */ defaultCommands(),
  /* @__PURE__ */ editHistory(),
  /* @__PURE__ */ searchWidget(),
  /* @__PURE__ */ highlightSelectionMatches(),
  /* @__PURE__ */ cursorPosition(),
  /* @__PURE__ */ indentGuides()
];
const readOnlySetup = [
  /* @__PURE__ */ matchBrackets(),
  /* @__PURE__ */ highlightBracketPairs(),
  /* @__PURE__ */ matchTags(),
  /* @__PURE__ */ highlightMatchingTags(),
  /* @__PURE__ */ highlightSelectionMatches(),
  /* @__PURE__ */ indentGuides(),
  /* @__PURE__ */ copyButton(),
  /* @__PURE__ */ readOnlyCodeFolding(blockCommentFolding, markdownFolding)
];
export {
  basicSetup,
  readOnlySetup
};
//# sourceMappingURL=setups.js.map
